"""
Lectura de instancias SCP

Estructura del archivo de entrada

Numero de filas     (n): corresponde a la cantidad de subsets entregados
Numero de columnas  (m): corresponde a la cantidad de las ubicaciones diponibles
Pesos de cada ubicación: lista de m pesos correspondiente a seleccionar cada ubicación.

for each subset (n) 
    Cantidad de elementos del subset
    indice de las ubicaciones que componene el sub set

"""

from cmath import inf
import numpy as np

def read_scp(f):
    with open(f,"r") as file:
        lines = file.readlines()
        lines = [line.replace('\n', ' ').strip().split(" ") for line in lines]

        u = []
        for item in lines:
            u += item
        u = list(map(int, u))
        m = u.pop(0)
        n = u.pop(0)
        C = [int(i) for i in u[:n]]
        Cnp = np.array(C)
        u = u[n:]
        print(n, m, len(C), u[0])

        SS = []
        c_s = []
        set = np.zeros((m,n))
        for j in range(m):
            # Obtengo el tamaño del subset
            aux = u.pop(0)

            # Capturo el subset y le resto 1 a cada valor, para usarlo como índice
            s = u[:aux]
            s = list(map(lambda elemento:elemento-1, s))
            #print("s", s)
            set[j,s] = 1
            #print(np.sum(set[j,:]))
            # Arego a la lista de subsets
            SS.append(s)

            # Calculo el costo asociado a cada subset
            #cost = [C[i] for i in range(m) if i in s]   # obtengo los pesos de cada ubicación pertenecientes al subset
            #print("cost", cost)
            #c_s.append(sum(cost))

            # Elimino el subset de u
            u = u[aux:]
        #print(len(SS))
        """        set = np.zeros((n,m))   # matriz de coberturas
        aux = 0
        for i in SS: 
            for j in i:
                set[aux,j] = 1
            aux += 1"""
        #print(set.shape)
        #print(C)

        SCP        = {}
        SCP["n"]   = n          # Numero de subsets / coberturas
        SCP["m"]   = m          # Numero de ubicaciones
        SCP["C_s"] = np.array(C) #np.array(c_s)       # Costo de seleccionar cada subset / cobertura
        SCP["C"]   = C          # Costo de cada ubicación
        SCP["S"]   = set        # Subsets de la instancia - matriz de cobertura

        #print(SCP["C_s"])

    
    return SCP

"""def validate_sol(SCP, sol):
    flag = True
    set = SCP["S"]
    #print(set)
    col_faltante = None
    for i in range(set.shape[1]):       # verifico que cada zona este cubierta
        sum_col = 0
        col = np.argwhere(set[:,i] == 1)
        sum_col = np.sum(sol[col])
        if sum_col < 1:
            flag = False
            col_faltante = i
            break
    return flag#, col_faltante"""

### Reparación simple
def reparaSimple(SCP, solution):
    sol =  np.reshape(solution, (SCP["n"],))
    set = SCP["S"]
    print(set.shape)
    numRep = 0
    indices = list(range(set.shape[0]))
    np.random.shuffle(indices)
    for i in indices:
        if np.sum(set[i,:] * sol) < 1:
            idxRestriccion = np.argwhere((set[i,:]) > 0)
            a = np.argmin(SCP["C_s"][idxRestriccion])
            idxMenorPeso = idxRestriccion[a]
            sol[idxMenorPeso[0]] = 1
            numRep += 1
    return sol

def fitness(SCP, sol):

    if sol.ndim == 1:
        cost = SCP["C_s"]
        fitness = np.sum(np.multiply(SCP["C_s"], sol))
        if fitness == 0:
            print("Solución optima")
    else:
        cost = SCP["C_s"]
        fitness = np.matmul(sol, cost)
        # verificar ceros
        if np.any(fitness == 0):
            print("s",sol[fitness == 0, :])
            fitness[fitness == 0] = inf
    #print(sol.shape, cost.shape, fitness.shape)
    return fitness

def main():
    file = "scp.txt"
    scp = read_scp(file)
    #print(scp)

    return 0



if __name__ == '__main__':   
	 main()